import { Component, EventEmitter, Input, OnDestroy, OnChanges, OnInit, Output, ApplicationRef } from '@angular/core';



@Component({
  selector: 'app-form',
  templateUrl: './form.component.html',
  styleUrls: ['./form.component.css']
})
export class FormComponent implements OnInit, OnChanges, OnDestroy {

  picArr = [];
  _item: any;
  KEY = 'hw_006';

  // @Input()
  set item(item) {
    this._item = item;
    // this.init();

  }
  get item() {
    return this._item;
  }

  @Output()
  update = new EventEmitter();



  constructor(private appRef: ApplicationRef) {

  }


  ngOnInit() {

    this.item = {};
    this.item.contentObj = {};

    const getData = (<any>window).courseware.getData;
    getData((data) => {

      if (data) {
        this.item = data;
      } else {
        this.item = {};
      }

      if (!this.item.contentObj) {
        this.item.contentObj = {};
      }

      console.log('~data:', data);
      this.init();
      this.refresh();

    }, this.KEY);

    // this.initData();
  }
  ngOnChanges() {

  }

  ngOnDestroy() {
  }


  init() {

    if (this.item.contentObj.picArr) {
      this.picArr = this.item.contentObj.picArr;
    } else {
      this.picArr = this.getDefaultPicArr();
      this.item.contentObj.picArr = this.picArr;
    }


    console.log('item:', this.item);
    // this.picArr = this.getDefaultPicArr();
    // this.item.contentObj.picArr = this.picArr;
    // console.log('this.item:;', this.picArr);

  }

  cardItemData() {
    return {
      left: {
        title: "",
        pic_url: "",
        audio_url: ""
      },
      right: {
        title: "",
        pic_url: "",
        audio_url: ""
      }
    };
  }

  getDefaultPicArr() {
    let arr = [];
    let item = this.cardItemData();
    for (let index = 0; index < 8; index++) {
      arr.push(item);
    }
    return arr;
  }



  initData() {


  }


  deleteItem(index) {
    if (index !== -1) {
      this.picArr.splice(index, 1);
    }

    // this.update.emit(this.item);
    this.save();
  }

  onImageUploadSuccessByItem(e, item) {
    item.pic_url = e.url;
    this.save();
  }

  onAudioUploadSuccessByItem(e, item) {
    item.audio_url = e.url;
    this.save();
  }

  addItem() {
    if (this.picArr.length < 10) {
      let item = this.cardItemData();
      this.picArr.push(item);
      this.saveItem();
    }
  }

  radioClick(it, radioValue) {
    it.radioValue = radioValue;

    this.saveItem();
  }

  clickCheckBox() {
    console.log(' in clickCheckBox');
    this.saveItem();
  }


  saveItem() {

    console.log(' in saveItem');
    // this.update.emit(this.item);
    this.save();
  }


  save() {
    (<any>window).courseware.setData(this.item, null, this.KEY);
    console.log('this.item = ' + JSON.stringify(this.item));
    this.refresh();
  }

  refresh() {
    setTimeout(() => {
      this.appRef.tick();
    }, 1);
  }

}

